function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { Drawer } from 'antd';
import { useState, useMemo, useRef, useEffect } from 'react';
import Modal from "../../../pisellModal";
var sizeMap = {
  small: 400,
  middle: 600,
  large: 800
};
var useDrawerState = function useDrawerState(operationContent) {
  // 抽屉是否显示
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    drawerVisible = _useState2[0],
    setDrawerVisible = _useState2[1];
  var _useState3 = useState(null),
    _useState4 = _slicedToArray(_useState3, 2),
    item = _useState4[0],
    setItem = _useState4[1];
  var timerRef = useRef();

  // 组件卸载时清除定时器
  useEffect(function () {
    return function () {
      if (timerRef.current) {
        clearTimeout(timerRef.current);
      }
    };
  }, []);
  var openDrawer = function openDrawer(item) {
    // 如果存在未完成的定时器，先清除
    if (timerRef.current) {
      clearTimeout(timerRef.current);
    }
    setDrawerVisible(true);
    setItem(item);
  };
  var closeDrawer = function closeDrawer() {
    // 如果存在未完成的定时器，先清除
    if (timerRef.current) {
      clearTimeout(timerRef.current);
    }
    setDrawerVisible(false);
    // 等待动画完成后再清除item
    timerRef.current = setTimeout(function () {
      var _item$afterClose;
      item === null || item === void 0 || (_item$afterClose = item.afterClose) === null || _item$afterClose === void 0 || _item$afterClose.call(item);
      setItem(null);
      timerRef.current = undefined;
    }, 300);
  };

  // 抽屉内容
  var drawerContent = useMemo(function () {
    if (item !== null && item !== void 0 && item.key && operationContent) {
      return operationContent[item.key];
    }
    return null;
  }, [item, operationContent]);

  // 容器属性
  var containerProps = useMemo(function () {
    if (!item) {
      return {};
    }
    var otherProps = {};
    if ((item === null || item === void 0 ? void 0 : item.openMode) === 'modal') {
      otherProps.footer = null;
    }
    return _objectSpread({
      width: sizeMap[item === null || item === void 0 ? void 0 : item.openContentSize],
      title: item === null || item === void 0 ? void 0 : item.openTitle
    }, otherProps);
  }, [item]);
  var Container = useMemo(function () {
    if ((item === null || item === void 0 ? void 0 : item.openMode) === 'drawer') {
      return Drawer;
    }
    return Modal;
  }, [item === null || item === void 0 ? void 0 : item.openMode]);
  return {
    drawerVisible: drawerVisible,
    setDrawerVisible: setDrawerVisible,
    openDrawer: openDrawer,
    closeDrawer: closeDrawer,
    drawerContent: drawerContent,
    Container: Container,
    containerProps: containerProps
  };
};
export default useDrawerState;